
/* corr.pl */

/* Varauduin joukkoon sääntöjä, joilla muunnella soinnun edellistä tahtia pikkuisen niin, että joka tahti ei olisi aivan uusi, mutta ei toisaalta olisi ihan saman toistoa.
Tässä muutetaan korkeutta ja voimakkuutta. */
corrx(Tahti,A,B,Ta,Tf):-
    tahti_len(Tahti,D0),
    Tf #=# Ta+D0,
    fd_domain(Sp,[0,4,5,7,9,12]),
    fd_domain(I,[0,1]),
    fd_domain(Vp,[0,10,20]),
    corr(Ta,A,B,sp(Sp,I),vp(Vp,10)).

corr(_,[],[],_,_).
corr(Ta,[note(_,Ch,Instrum,D,Pa,Va)|An], [note(Ta,Ch,Instrum,D,Pb,Vb)|Bn], sp(Dp,I), vp(Dv,Y)):-
    plim(Pb),
    Pb #=# Pa+Dp-2*I*Dp,
    Vb #=# Va+Dv-Y,
    Tb #=# Ta+D,
    corr(Tb,An,Bn,sp(Dp,I),vp(Dv,Y)).
