
/* Init.pl */
 /*  Heikki Välisuo */

dynamic(midi_cmd/3).
dynamic(midi_cmd4/4).
dynamic(tempo/1).
dynamic(tempo/7).
dynamic(div_tahti/2).

%:-fd_set_vector_max(1024),

bandi_name(musa).

init(Midi,Fmid,Chs):-
%	fd_vector_max(Vectormax),
%	write(fd_vector_max(Vectormax)),nl,
    randomize,
    abolish(div_tahti/2),
    assert_tahdit_t4,
    assert_tahdit_t3,
    fname(Chs,Fname),
    midi_init(Midi,Fmid,Fname).
%    test_dynamic.    

fname(Chs,Fname):-
    makestring(Chs,Str),
    bandi_name(Bname),
    format_to_atom(Fname,"data/~a~a",[Bname,Str]).

makestring([],'.mid').
makestring([X1|Xn],Str):-
    makestring(Xn,Strn),
    format_to_atom(Str,"_~d~a",[X1,Strn]).

midi_init(Midi,Fmid,Fname):-
    abolish(midi_cmd/3),
    abolish(midi_cmd4/4),
    abolish(tempo/1),
    abolish(tempo/7),
    open('midi.tmp',write,Midi),
%    popen('timidity -c timi.cfg  --volume=100, --drum-power=100 --chorus=s,100 --reverb=G,100  --anti-alias --temper-control --polyphony-reduction --noise-shaping=4 --verbose=0 -', write, Midi),
    set_stream_type(Midi,binary),
    open(Fname, write, Fmid),
    set_stream_type(Fmid,binary),
    add_stream_mirror(Midi,Fmid).  % everything that goes to timidity goes also to file musa.mid

%   popen('sleep 1; timidity -c timi.cfg  --volume=100, --drum-power=100 --anti-alias --temper-control --polyphony-reduction --noise-shaping=4 --verbose=0 -', write, Midi),


midi_init2(Midi,Tempo):-
    mthd_header(1,Tempo,0,Mthd),!,  % create MIDI header
    message(bytes_out(Midi,Mthd)),
    bytes_out(Midi,Mthd),!.

gtempo(500000).  % 500000 = 120 beat per minut (beat = 1/4 note )?

%    popen('timidity -c timi.cfg -A100,100a --chorus=s,60 --reverb=G,60 --anti-alias --fast-decay --voice-queue=5000 --polyphony-reduction --portamento --vibrato --temper-control --verbose=1 -', write, Midi),
