
/* soitin.pl Soittimien määrittelyt */
 /*  Heikki Välisuo */

/* soitin() on oikeastaan soitinryhmä, josta valitaan yksi kerrallaan soitettavaksi. Esimerkiksi soitin 1 soittaa jotain torviksi määrittelemistäni instrumenteista. */

soitin(1,II,t4):- sel_instrum([torvi],II).
soitin(2,II,t3):- sel_instrum([torvi],II).
soitin(3,II,t4):- sel_instrum([piano,harppu],II).
soitin(4,II,t3):- sel_instrum([harppu,piano],II).
soitin(5,II,t4):- sel_instrum([rumpu],II).
soitin(6,II,t3):- sel_instrum([rumpu],II).
soitin(7,II,t4):- sel_instrum([huilu,kello],II).
soitin(8,II,t3):- sel_instrum([huilu,kello],II).
soitin(9,II,t4):- sel_instrum([kitara,basso],II).
soitin(11,II,t3):- sel_instrum([kitara,basso],II).
soitin(12,['ChurchOrgan'],t4).
soitin(13,['ChurchOrgan'],t3).
soitin(14,II,t4):- sel_instrum([jousi],II).
soitin(15,II,t3):- sel_instrum([jousi],II).

sel_instrum([],[]).
sel_instrum([Ryhma1|Ryhman],Instruments):-
    setof(Soitin,instrument(Ryhma1,Soitin),Instr1),
    sel_instrum(Ryhman,Instrun),
    append(Instr1,Instrun,Instruments).

instrument(Ryhma,Soitin):- instrument(Ryhma,Soitin,_,_).

%instrument('Standard',0,128).
instrument(piano,'YamahaGrandPiano',0,0).
instrument(piano,'BrightYamahaGrand',1,0).
%instrument('Standard1',1,128).
%instrument('ElectricPiano',2,0).
%instrument('Standard2',2,128).
%instrument('Standard3',3,128).
instrument(piano1,'HonkyTonk',3,0).
%instrument('DetunedEP1',4,8).
%instrument(piano1,'RhodesEP',4,0).
%instrument('Standard4',4,128).
%instrument('DetunedEP2',5,8).
instrument(piano,'LegendEP2',5,0).
%instrument('Standard5',5,128).
%instrument('CoupledHarpsichord',6,8).
%instrument(piano2,'Harpsichord',6,0).
%instrument('Standard6',6,128).
%instrument('Standard7',7,128).
instrument(piano,'Clavinet',7,0).
%instrument(rumpu2,'Celesta',8,0).
%instrument('Room',8,128).
instrument(kello2,'Glockenspiel',9,0).
%instrument('Room1',9,128).
%instrument('Room2',10,128).
%instrument('MusicBox',10,0).
instrument(kello2,'Vibraphone',11,0).
%instrument('Room3',11,128).
instrument(kello,'Marimba',12,0).
%instrument('Room4',12,128).
%instrument('Room5',13,128).
instrument(kello2,'Xylophone',13,0).
%instrument('ChurchBell',14,8).
%instrument('Room6',14,128).
instrument(kello2,'TubularBells',14,0).
instrument(kello2,'Dulcimer',15,0).
%instrument('Room7',15,128).
instrument(urut1,'DrawbarOrgan',16,0).
%instrument('Power',16,128).
%instrument('DetunedOrgan1',16,8).
instrument(urut2,'PercussiveOrgan',17,0).
%instrument('DetunedOrgan2',17,8).
%instrument('Power1',17,128).
%instrument('Power2',18,128).
instrument(urut2,'RockOrgan',18,0).
instrument(urut,'ChurchOrgan',19,0).
%instrument('Power3',19,128).
%instrument('ChurchOrgan2',19,8).
instrument(urut2,'ReedOrgan',20,0).
%instrument('ItalianAccordion',21,8).
%instrument(urut1,'Accordian',21,0).
%instrument(urut1,'Harmonica',22,0).
%instrument(kitara2,'Bandoneon',23,0).
%instrument('Ukulele',24,8).
instrument(kitara,'NylonStringGuitar',24,0).
%instrument('Electronic',24,128).
instrument(kitara1,'SteelStringGuitar',25,0).
%instrument('TR-808',25,128).
%instrument('a12StringGuitar',25,8).
%instrument('Mandolin',25,16).
%instrument('HawaiianGuitar',26,8).
instrument(kitara,'JazzGuitar',26,0).
instrument(kitara,'CleanGuitar',27,0).
%instrument('FunkGuitar',28,8).
%instrument('PalmMutedGuitar',28,0).
%instrument('OverdriveGuitar',29,0).
%instrument('FeedbackGuitar',30,8).
%instrument('DistortionGuitar',30,0).
%instrument('GuitarHarmonics',31,0).
%instrument('GuitarFeedback',31,8).
instrument(basso,'AcousticBass',32,0).
%instrument('Jazz',32,128).
instrument(basso,'FingeredBass',33,0).
%instrument('Jazz1',33,128).
%instrument('Jazz2',34,128).
instrument(basso,'PickedBass',34,0).
%instrument('Jazz3',35,128).
instrument(basso,'FretlessBass',35,0).
%instrument('SlapBass',36,0).
%instrument('Jazz4',36,128).
%instrument('PopBass',37,0).
%instrument('SynthBass3',38,8).
%instrument('SynthBass1',38,0).
%instrument('SynthBass2',39,0).
%instrument('SynthBass4',39,8).
%instrument('SlowViolin',40,8).
instrument(jousi,'Violin',40,0).
%instrument('Brush',40,128).
%instrument('Brush1',41,128).
%instrument(jousi,'Viola',41,0).
%instrument('Brush2',42,128).
instrument(jousi,'Cello',42,0).
%instrument(torvi1,'Contrabass',43,0).
%instrument(torvi1,'Tremolo',44,0).
instrument(harppu1,'PizzicatoSection',45,0).
instrument(harppu,'Harp',46,0).
%instrument(rumpu2,'Timpani',47,0).
%instrument('OrchestralPad',48,8).
%instrument('OrchestraKit',48,128).
instrument(jousi,'Strings',48,0).
instrument(jousi,'SlowStrings',49,0).
%instrument('SynthStrings1',50,0).
%instrument('SynthStrings3',50,8).
%instrument('SynthStrings2',51,0).
%instrument('AhhChoir',52,0).
%instrument('OhhVoices',53,0).
%instrument('SynthVoice',54,0).
%instrument('OrchestraHit',55,0).
instrument(torvi2,'Trumpet',56,0).
instrument(torvi1,'Trombone',57,0).
instrument(torvi1,'Tuba',58,0).
%instrument('MutedTrumpet',59,0).
instrument(torvi,'FrenchHorns',60,0).
instrument(torvi3,'BrassSection',61,0).
%instrument('Brass2',61,8).
%instrument('SynthBrass3',62,8).
%instrument('SynthBrass1',62,0).
%instrument('SynthBrass2',63,0).
%instrument('SynthBrass4',63,8).
instrument(torvi3,'SopranoSax',64,0).
instrument(torvi3,'AltoSax',65,0).
instrument(torvi3,'TenorSax',66,0).
instrument(torvi3,'BaritoneSax',67,0).
instrument(torvi,'Oboe',68,0).
instrument(torvi,'EnglishHorn',69,0).
% instrument(torvi,'Bassoon',70,0).
instrument(torvi4,'Clarinet',71,0).
instrument(huilu1,'Piccolo',72,0).
instrument(huilu1,'Flute',73,0).
%instrument('Recorder',74,0).
instrument(huilu,'PanFlute',75,0).
instrument(huilu2,'BottleChiff',76,0).
%instrument(huilu1,'Shakuhachi',77,0).
%instrument('Whistle',78,0).
instrument(huilu,'Ocarina',79,0).
%instrument(huilu,'SquareLead',80,0).
%instrument('SineWave',80,8).
%instrument('SawWave',81,0).
instrument(huilu2,'CalliopeLead',82,0).
%instrument(huilu2,'ChifferLead',83,0).
%instrument('Charang',84,0).
%instrument('SoloVox',85,0).
%instrument('FifthSawtoothWave',86,0).
%instrument('Bass&Lead',87,0).
instrument(kello2,'Fantasia',88,0).
%instrument('WarmPad',89,0).
%instrument('Polysynth',90,0).
instrument(huilu1,'SpaceVoice',91,0).
instrument(kello2,'BowedGlass',92,0).
%instrument('MetalPad',93,0).
%instrument('HaloPad',94,0).
%instrument('SweepPad',95,0).
%instrument(kello3,'IceRain',96,0).
%instrument('Soundtrack',97,0).
instrument(kello2,'Crystal',98,0).
instrument(huilu1,'Atmosphere',99,0).
%instrument(huilu2,'Brightness',100,0).
%instrument(huilu2,'Goblin',101,0).
%instrument('EchoDrops',102,0).
%instrument(kello3,'StarTheme',103,0).
instrument(harppu2,'Sitar',104,0).
%instrument('Banjo',105,0).
instrument(harppu2,'Shamisen',106,0).
%instrument('TaishoKoto',107,8).
%instrument(kitara,'Koto',107,0).
%instrument(rumpu2,'Kalimba',108,0).
%instrument('BagPipe',109,0).
instrument(jousi1,'Fiddle',110,0).
%instrument('Shenai',111,0).
instrument(kello2,'TinkerBell',112,0).
instrument(rumpu,'Agogo',113,0).
%instrument(rumpu,'SteelDrums',114,0).
%instrument('Castanets',115,8).
instrument(rumpu,'Woodblock',115,0).
%instrument('ConcertBassDrum',116,8).
instrument(rumpu,'TaikoDrum',116,0).
instrument(rumpu,'MelodicTom',117,0).
%instrument('MeloTom2',117,8).
%instrument(rumpu,'SynthDrum',118,0).
%instrument('a808Tom',118,8).
%instrument('ReverseCymbal',119,0).
%instrument('FretNoise',120,0).
%instrument('BreathNoise',121,0).
%instrument('SeaShore',122,0).
%instrument('BirdTweet',123,0).
%instrument('Telephone',124,0).
%instrument('BurstNoise',125,9).
%instrument('Helicopter',125,0).
%instrument('Applause',126,0).
%instrument('GunShot',127,0).

/* Soittimien oktaavialueita */

plim(P,'SopranoSax'):- !,fd_domain(P,47,72).
plim(P,'AltoSax'):- !,fd_domain(P,59,72).
plim(P,'TenorSax'):- !,fd_domain(P,47,72).
plim(P,'BaritoneSax'):- !,fd_domain(P,47,60).
plim(P,'Trumpet'):- !,fd_domain(P,47,84).
plim(P,'Trombone'):- !,fd_domain(P,47,72).
plim(P,'Tuba'):- !,fd_domain(P,35,60).
plim(P,'FrenchHorns'):- !,fd_domain(P,47,84).
plim(P,'BrassSection'):- !,fd_domain(P,59,84).
plim(P,'Oboe'):- !,fd_domain(P,47,84).
plim(P,'EnglishHorn'):- !,fd_domain(P,47,72).
plim(P,'ChurchOrgan'):- !,fd_domain(P,11,60).
plim(P,'CleanGuitar'):- !,fd_domain(P,23,72).
plim(P,'SteelStringGuitar'):- !,fd_domain(P,23,72).
plim(P,'NylonStringGuitar'):- !,fd_domain(P,23,72).
plim(P,'AcousticBass'):- !,fd_domain(P,47,59).
plim(P,'FingeredBass'):- !,fd_domain(P,23,72).
plim(P,'PickedBass'):- !,fd_domain(P,23,72).
plim(P,'FretlessBass'):- !,fd_domain(P,23,72).

plim(P,'Clarinet'):- !,fd_domain(P,47,84).
plim(P,'Shamisen'):- !,fd_domain(P,12,85).
plim(P,'Agogo'):- !,fd_domain(P,23,72).
plim(P,'TaikoDrum'):- !,fd_domain(P,23,96).
plim(P,'Strings'):- !,fd_domain(P,47,72).
plim(P,'SlowStrings'):- !,fd_domain(P,47,72).
plim(P,'Violin'):- !,fd_domain(P,59,84).
plim(P,'Cello'):- !,fd_domain(P,47,72).
plim(P,'Harp'):- !,fd_domain(P,23,72).
plim(P,'BrightYamahaGrand'):- !,fd_domain(P,35,72).
plim(P,'Ocarina'):- !,fd_domain(P,47,84).
plim(P,'PanFlute'):- !,fd_domain(P,47,72).
%plim(P,''):- !,fd_domain(P,23,72).
%plim(P,''):- !,fd_domain(P,23,72).
plim(P,percussion):- fd_domain(P,35,81).
plim(P,_):- fd_domain(P,23,84).

lplim([],_):- !.
lplim([P1|Pn],Instr):-
    plim(P1,Instr),
    lplim(Pn,Instr).

